import 'package:bloc_stream/bloc_stream.dart';
import 'package:test/test.dart';

class CounterActions {
  static final Action<BlocStream<int>, int> increment =
      (bloc, add) => add(bloc.value + 1);

  static final Action<BlocStream<int>, int> decrement =
      (bloc, add) async => add(bloc.value - 1);

  static final Action<BlocStream<int>, int> delayedIncrement = (bloc, add) =>
      Future.delayed(Duration(milliseconds: 10))
          .then((_) => add(bloc.value + 1));
}

class CounterBloc extends BlocStream<int> {
  CounterBloc() : super(0);
}

void main() {
  group('CounterBloc', () {
    test('increments and decrements correctly', () {
      final counter = CounterBloc();

      expect(counter.value, 0);
      expect(counter, emitsInOrder([1, 0, 1, 0]));

      counter.add(CounterActions.increment);
      counter.add(CounterActions.decrement);
      counter.add(CounterActions.delayedIncrement);
      counter.add(CounterActions.decrement);

      counter.close();
    });
  });
}
